#![allow(dead_code, unused_imports)]

mod util;
mod statics;
mod component; use component::*;
mod card; use card::*;
mod data; use data::generate_cards;

fn main()
{
    let cards = generate_cards();

    let mut output = [
        String::from("<!DOCTYPE html><html><head>"),
        String::from("<title>Cards</title>"),
        String::from("<meta charset=\"UTF-8\">"),
        String::from("<link rel=\"stylesheet\" href=\"cards.css\">"),
        String::from("</head><body>"),
    ].concat();

    let mut front = String::new();
    let mut back = String::new();

    let mut size :Option<u8> = None;
    let mut count = 0;
    for card in &cards {
        let (card_front, card_back) = card.generate_html();

        if count >= 8 {
            front += "<br>";
            back += "<br>";

            output += &front;
            output += &back;

            front.clear();
            back.clear();

            size = None;
            count = 0;
        }

        if let Some(sz) = size {
            if sz != card.format.scale() {
                count += 8;
                size = None;
            } else {
                count += sz;
            }
        } else {
            count = card.format.scale();
            size = Some(count);
        }

        front += &card_front;
        back += &card_back;
    }

    if front.len() > 0 {
        front += "<br>";

        output += &front;
        output += &back;
    }

    output += "</body></html>";
    
    if std::fs::write("cards.html", output).is_err() {
        println!("error: failed to write to file.");
    }
}
