use crate::statics::AMMO_CLASS;

pub fn print_value(value:i8, relative:bool) -> String
{
    if value != 0 {
        if relative && value > 0 {
            format!("+{}", value)
        } else {
            format!("{}", value)
        }
    } else {
        String::from("—")
    }
}

pub fn print_size(value:i8) -> String
{
    if value != 0 {
        if value > 0 {
            format!("{}+", value)
        } else {
            format!("{}", value)
        }
    } else {
        String::from("—")
    }
}

pub fn print_ammo_class(index:Option<usize>) -> &'static str
{
    match index {
        Some(index) => AMMO_CLASS[index].name,
        None => "—",
    }
}

pub fn print_bubbles(value:u8) -> String
{
    let mut result = String::new();
    let mut rows = Vec::new();
    let mut value = value;

    let row_size = if value > 5 {
        value / ((value / 5) + (value % 5 > 0) as u8)
    } else {
        value
    };

    while value > row_size {
        rows.push(row_size);
        value -= row_size;
    }
    rows.push(value);

    for i in 0..rows.len() {
        for _ in 0..rows[i] {
            result += "<span>◯</span>";
        }
        if i < rows.len() - 1 { result += "<br>"; }
    }
    result
}
